/*/////////////////////////////////////////////////////////////////////////
Name : Gajendra Singh
File : Dialog Class File.
Date : October 20, 2005
Description : This code is the main file which generates the window to handle 
data coming from environmental sensors and clam sensors.

////////////////////////////////////////////////////////////////////////*/
#include <process.h>
#include "stdafx.h"
#include "tab.h"
#include "TabDlgNewClass.h"
#include<stdlib.h>
#include<stdio.h>
#include<string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Global variables
CSerialCom *p;
char str[400];
float slot[400];
FILE *fp;

unsigned __stdcall ThreadPoll (void *Param);     	//Multithreaded stand alone function prototype.


TabDlgNewClass::TabDlgNewClass(CWnd* pParent /*=NULL*/)
	: CDialog(TabDlgNewClass::IDD, pParent)
{
	//{{AFX_DATA_INIT(TabDlgNewClass)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_ed2 = 0;
	m_ed1 = 0;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInit = false;
	p1=NULL;
	p2=NULL;

  m_bStartStop = FALSE ;
  srand( (unsigned)time( NULL ) );

}


void TabDlgNewClass::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TabDlgNewClass)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	//DDX_Text(pDX, IDC_EDIT2, m_ed2);
	//DDX_Text(pDX, IDC_EDIT1, m_ed1);
	DDX_Control(pDX, IDC_TAB, m_ctrlTAB);
}




// CTabDlg message handlers

BOOL TabDlgNewClass::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Creating Tab pages for the windows
	p1 = new CTabPageOne();
	p1->Create(IDD_DIALOG_PAGE1,m_ctrlTAB.GetWindow(IDD_DIALOG_PAGE1));
	p2 = new CTabPageTwo();
	p2->Create(IDD_DIALOG_PAGE2,m_ctrlTAB.GetWindow(IDD_DIALOG_PAGE2));
	m_ctrlTAB.AddTabPane("Tab 1",p1);
	m_ctrlTAB.AddTabPane("Tab 2",p2);

//////////////////////////////////////////////////////////////////////////////////
//this part of the code initializes 16 sensor windows and 7 environmental       //
//sensors windows in tab pages one and two respectively.                        //
//////////////////////////////////////////////////////////////////////////////////


	CRect rect;											//Window initializtion for environmental sensor One
    p2->GetDlgItem(IDC_OSCOPE)->GetWindowRect(rect) ;
    ScreenToClient(rect) ;

	m_OScopeCtrl.Create(WS_VISIBLE | WS_CHILD, rect, p2) ; 
	m_OScopeCtrl.SetRange(-15.0, 50.0, 1) ;
	m_OScopeCtrl.SetYUnits("Value(C/F)") ;
	m_OScopeCtrl.SetXUnits("Temperature") ;
	m_OScopeCtrl.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl.SetPlotColor(RGB(255, 255, 255)) ;
	
	CRect rect1;										//Window initializtion  for environmental sensor Two
	p2->GetDlgItem(IDC_OSCOPE1)->GetWindowRect(rect1) ;
	ScreenToClient(rect1) ;
	
	m_OScopeCtrl1.Create(WS_VISIBLE | WS_CHILD, rect1, p2) ; 
	m_OScopeCtrl1.SetRange(0, 110, 0) ;
	m_OScopeCtrl1.SetYUnits("Value(mS/cm)") ;
	m_OScopeCtrl1.SetXUnits("Conductivity") ;
	m_OScopeCtrl1.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl1.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl1.SetPlotColor(RGB(255, 255, 255)) ;

	
	CRect rect2;										//Window initializtion for environmental sensor Three
	p2->GetDlgItem(IDC_OSCOPE2)->GetWindowRect(rect2) ;
	ScreenToClient(rect2) ;
	
	m_OScopeCtrl2.Create(WS_VISIBLE | WS_CHILD, rect2, p2) ; 
	m_OScopeCtrl2.SetRange(0, 50.0, 1) ;
	m_OScopeCtrl2.SetYUnits("Value(mg/L)") ;
	m_OScopeCtrl2.SetXUnits("Dissolved Oxygen") ;
	m_OScopeCtrl2.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl2.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl2.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect3;										//Window initializtion for environmental sensor Four
	p2->GetDlgItem(IDC_OSCOPE3)->GetWindowRect(rect3) ;
	ScreenToClient(rect3) ;
	
	m_OScopeCtrl3.Create(WS_VISIBLE | WS_CHILD, rect3, p2) ; 
	m_OScopeCtrl3.SetRange(-200, 50, 1) ;
  	m_OScopeCtrl3.SetYUnits("Value(ft)") ;
	m_OScopeCtrl3.SetXUnits("Depth") ;
	m_OScopeCtrl3.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl3.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl3.SetPlotColor(RGB(255, 255, 255)) ;
	
	CRect rect4;										//Window initializtion for environmental sensor Five
	p2->GetDlgItem(IDC_OSCOPE4)->GetWindowRect(rect4) ;
	ScreenToClient(rect4) ;
	
	m_OScopeCtrl4.Create(WS_VISIBLE | WS_CHILD, rect4, p2) ; 
	m_OScopeCtrl4.SetRange(0, 14.0, 1) ;
	m_OScopeCtrl4.SetYUnits("Value") ;
	m_OScopeCtrl4.SetXUnits("pH") ;
	m_OScopeCtrl4.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl4.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl4.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect5;										//Window initializtion for environmental sensor Six
	p2->GetDlgItem(IDC_OSCOPE5)->GetWindowRect(rect5) ;
	ScreenToClient(rect5) ;
	
	m_OScopeCtrl5.Create(WS_VISIBLE | WS_CHILD, rect5, p2) ; 
	m_OScopeCtrl5.SetRange(-10, 10.0, 1) ;
	m_OScopeCtrl5.SetYUnits("Value(NTU)") ;
	m_OScopeCtrl5.SetXUnits("Turbidity") ;
	m_OScopeCtrl5.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl5.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl5.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect6;										//Window initializtion for environmental sensor Seven
	p2->GetDlgItem(IDC_OSCOPE6)->GetWindowRect(rect6) ;
	ScreenToClient(rect6) ;
	
	m_OScopeCtrl6.Create(WS_VISIBLE | WS_CHILD, rect6, p2) ; 
	m_OScopeCtrl6.SetRange(-5, 5.0, 1) ;
	m_OScopeCtrl6.SetYUnits("Value(ug/L)") ;
	m_OScopeCtrl6.SetXUnits("Chlorophyll") ;
	m_OScopeCtrl6.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_OScopeCtrl6.SetGridColor(RGB(120, 102, 120)) ;
	m_OScopeCtrl6.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect7;										//Window initialization for Clam sensor One
	p1->GetDlgItem(IDC_OSCOPE)->GetWindowRect(rect7) ;
	ScreenToClient(rect7) ;
	
	m_OScopeCtrl7.Create(WS_VISIBLE | WS_CHILD, rect7, p1) ; 
	m_OScopeCtrl7.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl7.SetYUnits("Value") ;
	m_OScopeCtrl7.SetXUnits("Clam Sensor 1") ;
	m_OScopeCtrl7.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl7.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl7.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect8;										//Window initialization for Clam sensor Two
	p1->GetDlgItem(IDC_OSCOPE1)->GetWindowRect(rect8) ;
	ScreenToClient(rect8) ;
	
	m_OScopeCtrl8.Create(WS_VISIBLE | WS_CHILD, rect8, p1) ; 
	m_OScopeCtrl8.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl8.SetYUnits("Value") ;
	m_OScopeCtrl8.SetXUnits("Clam Sensor 2") ;
	m_OScopeCtrl8.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl8.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl8.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect9;										//Window initialization for Clam sensor Three
	p1->GetDlgItem(IDC_OSCOPE2)->GetWindowRect(rect9) ;
	ScreenToClient(rect9) ;
	
	m_OScopeCtrl9.Create(WS_VISIBLE | WS_CHILD, rect9, p1) ; 
	m_OScopeCtrl9.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl9.SetYUnits("Value") ;
	m_OScopeCtrl9.SetXUnits("Clam Sensor 3") ;
	m_OScopeCtrl9.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl9.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl9.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect10;										//Window initialization for Clam sensor Four
	p1->GetDlgItem(IDC_OSCOPE3)->GetWindowRect(rect10) ;
	ScreenToClient(rect10) ;
	
	m_OScopeCtrl10.Create(WS_VISIBLE | WS_CHILD, rect10, p1) ; 
	m_OScopeCtrl10.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl10.SetYUnits("Value") ;
	m_OScopeCtrl10.SetXUnits("Clam Sensor 4") ;
	m_OScopeCtrl10.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl10.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl10.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	
	CRect rect11;										//Window initialization for Clam sensor Five.
	p1->GetDlgItem(IDC_OSCOPE4)->GetWindowRect(rect11) ;
	ScreenToClient(rect11) ;
	
	m_OScopeCtrl11.Create(WS_VISIBLE | WS_CHILD, rect11, p1) ; 
	m_OScopeCtrl11.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl11.SetYUnits("Value") ;
	m_OScopeCtrl11.SetXUnits("Clam Sensor 5") ;
	m_OScopeCtrl11.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl11.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl11.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect12;										//Window initialization for Clam sensor Six
	p1->GetDlgItem(IDC_OSCOPE5)->GetWindowRect(rect12) ;
	ScreenToClient(rect12) ;
	
	m_OScopeCtrl12.Create(WS_VISIBLE | WS_CHILD, rect12, p1) ; 
	m_OScopeCtrl12.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl12.SetYUnits("Value") ;
	m_OScopeCtrl12.SetXUnits("Clam Sensor 6") ;
	m_OScopeCtrl12.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl12.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl12.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect13;										//Window initialization for Clam sensor Seven
	p1->GetDlgItem(IDC_OSCOPE6)->GetWindowRect(rect13) ;
	ScreenToClient(rect13) ;
	
	m_OScopeCtrl13.Create(WS_VISIBLE | WS_CHILD, rect13, p1) ; 
	m_OScopeCtrl13.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl13.SetYUnits("Value") ;
	m_OScopeCtrl13.SetXUnits("Clam Sensor 7") ;
	m_OScopeCtrl13.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl13.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl13.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	
	CRect rect14;										//Window initialization for Clam sensor Eight
	p1->GetDlgItem(IDC_OSCOPE7)->GetWindowRect(rect14) ;
	ScreenToClient(rect14) ;
	
	m_OScopeCtrl14.Create(WS_VISIBLE | WS_CHILD, rect14, p1) ; 
	m_OScopeCtrl14.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl14.SetYUnits("Value") ;
	m_OScopeCtrl14.SetXUnits("Clam Sensor 8") ;
	m_OScopeCtrl14.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl14.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl14.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect15;										//Window initialization for Clam sensor Nine
	p1->GetDlgItem(IDC_OSCOPE8)->GetWindowRect(rect15) ;
	ScreenToClient(rect15) ;
	
	m_OScopeCtrl15.Create(WS_VISIBLE | WS_CHILD, rect15, p1) ; 
	m_OScopeCtrl15.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl15.SetYUnits("Value") ;
	m_OScopeCtrl15.SetXUnits("Clam Sensor 9") ;
	m_OScopeCtrl15.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl15.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl15.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect16;										//Window initialization for Clam sensor Ten
	p1->GetDlgItem(IDC_OSCOPE9)->GetWindowRect(rect16) ;
	ScreenToClient(rect16) ;
	
	m_OScopeCtrl16.Create(WS_VISIBLE | WS_CHILD, rect16, p1) ; 
	m_OScopeCtrl16.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl16.SetYUnits("Value") ;
	m_OScopeCtrl16.SetXUnits("Clam Sensor 10") ;
	m_OScopeCtrl16.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl16.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl16.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect17;										//Window initialization for Clam sensor Eleven.
	p1->GetDlgItem(IDC_OSCOPE10)->GetWindowRect(rect17) ;
	ScreenToClient(rect17) ;
	
	m_OScopeCtrl17.Create(WS_VISIBLE | WS_CHILD, rect17, p1) ; 
	m_OScopeCtrl17.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl17.SetYUnits("Value") ;
	m_OScopeCtrl17.SetXUnits("Clam Sensor 11") ;
	m_OScopeCtrl17.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl17.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl17.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect18;										//Window initialization for Clam sensor Twelve.
	p1->GetDlgItem(IDC_OSCOPE11)->GetWindowRect(rect18) ;
	ScreenToClient(rect18) ;
	
	m_OScopeCtrl18.Create(WS_VISIBLE | WS_CHILD, rect18, p1) ; 
	m_OScopeCtrl18.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl18.SetYUnits("Value") ;
	m_OScopeCtrl18.SetXUnits("Clam Sensor 12") ;
	m_OScopeCtrl18.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl18.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl18.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect19;										//Window initialization for Clam sensor Thirteen
	p1->GetDlgItem(IDC_OSCOPE12)->GetWindowRect(rect19) ;
	ScreenToClient(rect19) ;
	
	m_OScopeCtrl19.Create(WS_VISIBLE | WS_CHILD, rect19, p1) ; 
	m_OScopeCtrl19.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl19.SetYUnits("Value") ;
	m_OScopeCtrl19.SetXUnits("Clam Sensor 13") ;
	m_OScopeCtrl19.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl19.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl19.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect20;										//Window initialization for Clam sensor Fourteen
	p1->GetDlgItem(IDC_OSCOPE13)->GetWindowRect(rect20) ;
	ScreenToClient(rect20) ;
	
	m_OScopeCtrl20.Create(WS_VISIBLE | WS_CHILD, rect20, p1) ; 
	m_OScopeCtrl20.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl20.SetYUnits("Value") ;
	m_OScopeCtrl20.SetXUnits("Clam Sensor 14") ;
	m_OScopeCtrl20.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl20.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl20.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect21;										//Window initialization for Clam sensor Fifteen
	p1->GetDlgItem(IDC_OSCOPE14)->GetWindowRect(rect21) ;
	ScreenToClient(rect21) ;
	
	m_OScopeCtrl21.Create(WS_VISIBLE | WS_CHILD, rect21, p1) ; 
	m_OScopeCtrl21.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl21.SetYUnits("Value") ;
	m_OScopeCtrl21.SetXUnits("Clam Sensor 15") ;
	m_OScopeCtrl21.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl21.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl21.SetPlotColor(RGB(255, 255, 255)) ;
	
	
	CRect rect22;										//Window initialization for Clam sensor Sixteen
	p1->GetDlgItem(IDC_OSCOPE15)->GetWindowRect(rect22) ;
	ScreenToClient(rect22) ;
	
	m_OScopeCtrl22.Create(WS_VISIBLE | WS_CHILD, rect22, p1) ; 
	m_OScopeCtrl22.SetRange(0, 2500.0, 1) ;
	m_OScopeCtrl22.SetYUnits("Value") ;
    m_OScopeCtrl22.SetXUnits("Clam Sensor 16") ;
	m_OScopeCtrl22.SetBackgroundColor(RGB(0,0,255)) ;
	m_OScopeCtrl22.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl22.SetPlotColor(RGB(255, 255, 255)) ;

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void TabDlgNewClass::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
///////////////////////////////////////////////////////////////////////
//Here is the function which does a task based on a configured timer.//
//This particular fuction is configured to plot data every 500 ms.   //
///////////////////////////////////////////////////////////////////////


void TabDlgNewClass::OnTimer(UINT nIDEvent) {
  
	char *pt;
	char stra[200];
	int j =0;
	
	//We tokenize the string we obtained in the stand alone multithreaded function
	

	pt= strtok(str,",");
								
	do{
		pt = strtok(NULL, ", ");
		if(pt) sprintf(stra,"\n%s",pt);
		slot[j] = atof(stra);
		j++;
	}while(pt);

	// append the new value to the plot
	m_OScopeCtrl.AppendPoint(slot[0]);
	m_OScopeCtrl1.AppendPoint(slot[1]);
	m_OScopeCtrl2.AppendPoint(slot[2]);
  	m_OScopeCtrl3.AppendPoint(slot[3]);
  	m_OScopeCtrl4.AppendPoint(slot[4]);
  	m_OScopeCtrl5.AppendPoint(slot[5]);
  	m_OScopeCtrl6.AppendPoint(slot[6]);
  	m_OScopeCtrl7.AppendPoint(slot[8]);
  	m_OScopeCtrl8.AppendPoint(slot[9]);
  	m_OScopeCtrl9.AppendPoint(slot[10]);
  	m_OScopeCtrl10.AppendPoint(slot[11]);
  	m_OScopeCtrl11.AppendPoint(slot[12]);
  	m_OScopeCtrl12.AppendPoint(slot[13]);
  	m_OScopeCtrl13.AppendPoint(slot[14]);
  	m_OScopeCtrl14.AppendPoint(slot[15]);
  	m_OScopeCtrl15.AppendPoint(slot[16]);
  	m_OScopeCtrl16.AppendPoint(slot[17]);
  	m_OScopeCtrl17.AppendPoint(slot[18]);
  	m_OScopeCtrl18.AppendPoint(slot[19]);
  	m_OScopeCtrl19.AppendPoint(slot[20]);
  	m_OScopeCtrl20.AppendPoint(slot[21]);
  	m_OScopeCtrl21.AppendPoint(slot[22]);
  	m_OScopeCtrl22.AppendPoint(slot[23]);
  
  	CDialog::OnTimer(nIDEvent);
}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR TabDlgNewClass::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void TabDlgNewClass::OnMove(int x, int y)
{
	m_ctrlTAB.OnMove(x,y); 
}

void TabDlgNewClass::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);
	m_ctrlTAB.SetDefaultPane(1);
}


BEGIN_MESSAGE_MAP(TabDlgNewClass, CDialog)
	//{{AFX_MSG_MAP(TabDlgNewClass)
	ON_BN_CLICKED(IDC_RunStop, OnRunStop)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	//}}AFX_MSG_MAP
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_MOVE()
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//ON_EN_SETFOCUS(IDC_EDIT1, OnSetfocusEdit1)

END_MESSAGE_MAP()

void TabDlgNewClass::OnRunStop() 
{
	m_bStartStop ^= TRUE;
	
	if (m_bStartStop)
    SetTimer(1,500,NULL);else
    KillTimer(1);
	
}

void TabDlgNewClass::OnCancel() 
{
	// TODO: Add extra cleanup here
  if (!m_bStartStop)
    KillTimer(1) ;
	CDialog::OnCancel();
}

void TabDlgNewClass::OnTest() 
{
	UpdateData(true);
	BYTE data=0;
	unsigned int thread_id;

	if(!(port.OpenPort("COM1")))
	{
		MessageBox("Cannot open Communication Port.Please\nquit the application & re-start your PC.","Error",MB_OK+MB_ICONERROR);
	}
	else
	{
		MessageBox("opened port");
		if(!(port.ConfigurePort(19200,8,0,NOPARITY ,ONESTOPBIT )))
		{
			MessageBox("Cannot Configure Communication Port","Error",MB_OK+MB_ICONERROR);
			port.ClosePort();
		}
		else
		{
			if(!(port.SetCommunicationTimeouts(0,5000,0,0,0)))
			{
				MessageBox("Cannot Configure Communication Timeouts","Error",MB_OK+MB_ICONERROR);
			}
			
			if((fp=fopen("test.txt","w"))==NULL)
			{
							MessageBox("Cannot Write to Port");
							port.ClosePort();
							fclose(fp);
			}
			m_ed1='A';
			port.WriteByte(m_ed1);	

			p = &port;
		    _beginthreadex (NULL, 0, ThreadPoll, NULL, 0, &thread_id);

		}

	}
	
}

	
void TabDlgNewClass::OnQuit() 
{
			m_ed1='Q';
			port.WriteByte(m_ed1);
			fclose(fp);
			port.ClosePort();
	
}

unsigned __stdcall ThreadPoll (void *Param) {

	TabDlgNewClass t;
	BYTE data = 0;
	int i=0;
	do{
		if(!(p->ReadByte(data))){
			t.MessageBox("Timeout on getting Response.Please ensure that\nyou have connected the loop back plug to com1.","Timeout",MB_OK+MB_ICONEXCLAMATION);
			p->ClosePort();
			break;
		}
		else{
			t.m_ed2= data;
			putc(t.m_ed2,fp);
			str[i]=data;
			i++;
			if(data == '\n'){
				str[i] = '\0';
				i=0;
			}
		}
	}while(1);

	return 0;
}
void TabDlgNewClass::OnClose() 
{
OnOK();	
}
