/*/////////////////////////////////////////////////////////////////////////
Name : Gajendra Singh
File : USB Interface Class header file.
Date : April 20, 2005
////////////////////////////////////////////////////////////////////////*/


#if !defined(AFX_DROPDIALOG_H__144F7F48_B861_41C3_A7DD_4ED2EFFB17FB__INCLUDED_)
#define AFX_DROPDIALOG_H__144F7F48_B861_41C3_A7DD_4ED2EFFB17FB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DropDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDropDialog dialog

#define MAX_DRIVER_NAME 64
#define DEVICE_DESCRIPTOR_SIZE 32 /* bigger than we need */
#define MAX_ITEMS_IN_LB 1024
#define MAX_BUFFER_SIZE 512
#define BYTES_PER_LINE 0x10

typedef LONG USBD_STATUS;
typedef struct _USBD_ISO_PACKET_DESCRIPTOR {
    ULONG Offset;       // INPUT Offset of the packet from the begining of the
                        // buffer.

    ULONG Length;       // OUTPUT length of data received (for in).
                        // OUTPUT 0 for OUT.
    USBD_STATUS Status; // status code for this packet.     
} USBD_ISO_PACKET_DESCRIPTOR, *PUSBD_ISO_PACKET_DESCRIPTOR;

#define MAINTAIN_OUTPUT_BOX(hO, nI) \
    nI = SendMessage (hO, LB_GETCOUNT, 0, 0); \
    while (nI >= MAX_ITEMS_IN_LB) { \
        SendMessage (hO, LB_DELETESTRING, 0, 0); \
        nI = SendMessage (hO, LB_GETCOUNT, 0, 0); \
    }



typedef void (*VF)(void *);


void TestThread(void* lpParameter);
bool bOpenDriver (HANDLE * phDeviceHandle, PCHAR devname);
void DumpBuffer(PVOID pvBuffer, ULONG length, HWND hOutputBox);

extern CPaintDC *viewdc;
extern int currval;
extern int currx;
extern CWnd* view;

class CDropDialog : public CDialog
{
// Construction
public:
	CDropDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDropDialog)
	enum { IDD = IDD_DIALOG1 };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


   CWnd*    hOutputBox;
   HANDLE  hDevice;
   char    pcDriverName[MAX_DRIVER_NAME];
   BOOLEAN bResult;
   int     nBytes;
   int     nItems;
   HFONT   hFont;
   ULONG   ulLength;
   char    tempbuff[256];
	LARGE_INTEGER llnHPTimerFreq;	// High Performance Timer: Frequency
	LARGE_INTEGER llnHPT1;			// High Performance Timer: Time 1
	LARGE_INTEGER llnHPT2;			// High Performance Timer: Time 2
	LARGE_INTEGER llnT_uSec;		// Time in microseconds

	char *build_time;
	char *build_date;
	VF voidfunc;
	
	
	

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDropDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDropDialog)
	afx_msg void OnStartIsoStream();
	afx_msg void OnStopIsoStream();
	afx_msg void OnReadIsoBuffer();
	afx_msg void OnStartReadThread();
	afx_msg void OnStopReadThread();
	afx_msg void OnQuit();
	afx_msg void OnAbout();
	afx_msg void OnClear();
	afx_msg void OnInit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DROPDIALOG_H__144F7F48_B861_41C3_A7DD_4ED2EFFB17FB__INCLUDED_)
